<?php
/* * 
 * 
 * Script kann frei verwendet werden. Eine Haftung der miniPay GmbH ist ausgeschlossen.
 * 
 * Dieses Skript ist nur ein Beispiel, wie man die API von miniPay benutzen kann. 
 * Grunstzlich ist es von System zu System unterschiedlich und es gibt immer mehrer Wege 
 * zum Ziel.
 * 
 * DAS FOLGENDE SCRIPT ZEIGT BEISPIELHAFT DIE BENUTZUNG DER ABO SCHNITTSTELLE
 * 
 * @author      Janis Kosarew, miniPay GmbH
 * @date        2013-03-06 12:59:13
 *  
 */

// Ein Parr Hilfsvariabeln
$index = (isset($_REQUEST['go']) && !empty($_REQUEST['go']))?$_REQUEST['go']:'';
$_content = '';

// Testaccount von miniPay
$_oid = '1000'; // Ihre miniPay-Kunden-ID
$_sec = md5('abcde'); // Security-String muss immer md5-verschlsselt an die API gesendet werden
$_apiurl = 'https://www.minipay.de/capp/gateways/'; // URL zur miniPay API



/* *
 * Einsprungpunkt der Beispiel PHP-Umgebung
 * Registrierung:
 * - Ldt HTML Inhalt
 */
if($index == 'registrierung')
{
    $_content .= file_get_contents('registrierung_1.html');
} 
/* *
 * Registrierungsformular wurde gesendet
 * Registrierung: Schritt 1
 * - Aufruf des tan_send Webservice
 * - Bei Erfolg -> Zwischenspeichern der Daten
 *              -> lade Schritt 2      
 * - Bei Fehler -> gebe Fehlermeldung aus
 */
else if($index == 'reg_validate')
{    
    // Wurde das Formular abgesendet?
    if(isset($_REQUEST['regstep1']) && !empty($_REQUEST['regstep1']))
    {
        // API-Aufruf: check_accountdata
        // Antwort wird als XML geliefert.
        $xml = simplexml_load_file($_apiurl.'check_accountdata?oid='.$_oid.'&sec='.$_sec.'&customer_account='.$_REQUEST['kontonr'].'&customer_bankcode='.$_REQUEST['blz']);
        
        // Verarbeitung der API-Antwort
        if($xml->result == 'error') // Ist ein Fehler aufgetreten?
        {
            $_content .= '<h1>Es sind Fehler aufgetreten:</h1>';
            foreach($xml->errors->error as $error) // Liste alle Fehler auf
            { 
                // Fehlerverarbeitung, muss angepasst werden.
                $_content .= $error.'<br />'; 
                
            }
            $_content .= file_get_contents('registrierung_1.html');

            // Damit man das Formular nicht nocheinmal eintippen muss
            foreach($_REQUEST as $key => $val) 
            {
                if(strpos($_content, '###'.$key.'###')) {
                    $_content = str_replace('###'.$key.'###', $val, $_content); 
                }               
            }                        
        } 
        else // Wenn alles OK ist
        {
            // Daten werden weiter verarbeiten
            // API-Aufruf: tan_send
            // Antwort wird als XML geliefert.
            $xml = simplexml_load_file($_apiurl.'tan_send?oid='.$_oid.'&sec='.$_sec.'&customer_phone='.$_REQUEST['handynr']);

            // Verarbeitung der API-Antwort
            if($xml->result == 'error') // Ist ein Fehler aufgetreten?
            {
                $_content .= '<h1>Es sind Fehler aufgetreten:</h1>';
                foreach($xml->errors->error as $error) // Liste alle Fehler auf
                { 
                    // Fehlerverarbeitung, muss angepasst werden.
                    $_content .= $error.'<br />';                
                }
            } 
            else // Wenn alles OK ist
            { 
                // Daten werden weiter verarbeiten
                // - Hier knnen die Daten z.B. in eine Datenbank zwischengespeichert werden
                // ( Da dieses Beispiel keine Datenbank hat werden die Daten aus diesem Schritt
                //   per serialize in den nchsten bernommen )
                $_content .= file_get_contents('registrierung_2.html');
                $_content .= '<input type="hidden" name="data" value="'. htmlspecialchars(serialize($_REQUEST)).'" form="reg" />';
            }
        }                                
    } 
    else
    {
        $_content .= '<h1>Es ist ein Fehler unterlaufen.</h1>';
    }
} 
/* *
 * Tan wurde eingegeben
 * Registrierung: Schritt 2
 * - Die Tan wurde erfolgreich gesendet
 * - Benutzer muss die Tan eingeben
 * - Daten aus Schritt 1 werden geholt
 * - 
 */
else if($index == 'reg_exec')
{
    // Hole die Daten aus Schritt 1
    $data = unserialize($_REQUEST['data']);
    
    // Abo Eisntellungen
    $shopDomain = 'www.testshop.de'; // Wie heisst Ihr Shop?
    $productName = 'Abo Test'; // Name des Abonnements
    $productId = ''; // Spezifische ID fr Ihr System
    $testmode = '1';

    // API-Aufruf: subscription_create
    $xml = simplexml_load_file($_apiurl.'subscription_create?oid='.$_oid.'&sec='.$_sec.'&customer_phone='.$data['handynr'].'&customer_email='.$data['email'].'&customer_name='.$data['kontoinhaber'].'&customer_account='.$data['kontonr'].'&customer_bankcode='.$data['blz'].'&customer_tan='.$_REQUEST['tan'].'&shopDomain='.$shopDomain.'&productName='.$productName.'&productId='.$productId.'&testmode='.$testmode.'');

    if($xml->result == 'error') // Ist ein Fehler aufgetreten?
    {
        $_content .= '<h1>Es sind Fehler aufgetreten, das Abonnement wurde nicht erstellt:</h1>';
        $_content .= '<p>';
        foreach($xml->errors->error as $error) // Liste alle Fehler auf
        {            
            // Fehlerverarbeitung 
            switch($error)
            {
                case 'customer_bankcode_validation':
                        $_content .= 'Ihre BLZ ist ung&uuml;ltig. Bitte pr&uuml;fen sie, ob BLZ und Kontonummer richtig sind.<br />';
                    break;
                case 'customer_account_validation':
                        $_content .= 'Ihre Kontonummer ist ung&uuml;ltig. Bitte pr&uuml;fen sie, ob BLZ und Kontonummer richtig sind.<br />';
                    break;
                default:
                    $_content .= $error.'<br />';
            }
        }
        $_content .= '<p>';
    } 
    else // Wenn alles OK ist
    { 
        // Liefert die subscription_id zurck
        // Diese sollte in ein Datenbank zwecks bersicht gespeichert werden, falls der 
        // Abonnement-Kunde nderungswnsche hat. Anhand dieser ID kann man spter die 
        // Einstellungen des Abonnements ndern        
        $subid = $xml->subscription_id;
        
        $_content .= '<h1>Vielen Dank für Ihre Registrierung.</h1>';
        $_content .= '<p>Informationen: subscription_id ist '.$subid.'</p>';
    }        
} 
else 
{
    $_content .= file_get_contents('registrierung_1.html');
}

include('template.php');